src/Entity/Entreprise.php
<?php

namespace App\Entity;

use App\Repository\EntrepriseRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: EntrepriseRepository::class)]
class Entreprise
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 100)]
    private ?string $raisonSocial = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    private ?\DateTimeInterface $dateCreation = null;

    #[ORM\Column(length: 100)]
    private ?string $adresse = null;

    #[ORM\Column(length: 20)]
    private ?string $cp = null;

    #[ORM\Column(length: 50)]
    private ?string $ville = null;

    #[ORM\OneToMany(mappedBy: 'entreprise', targetEntity: Employe::class, orphanRemoval: true)]
    #[ORM\OrderBy(['nom' => 'ASC'])]
    private Collection $employes;

    public function __construct()
    {
        $this->employes = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getRaisonSocial(): ?string
    {
        return $this->raisonSocial;
    }

    public function setRaisonSocial(string $raisonSocial): static
    {
        $this->raisonSocial = $raisonSocial;

        return $this;
    }

    public function getDateCreation(): ?\DateTimeInterface
    {
        return $this->dateCreation;
    }

    public function getFormattedDateCreation(): string
    {
        return $this->dateCreation->format('d/m/Y');
    }

    public function setDateCreation(\DateTimeInterface $dateCreation): static
    {
        $this->dateCreation = $dateCreation;

        return $this;
    }

    public function getAdresse(): ?string
    {
        return $this->adresse;
    }

    public function setAdresse(string $adresse): static
    {
        $this->adresse = $adresse;

        return $this;
    }

    public function getCp(): ?string
    {
        return $this->cp;
    }

    public function setCp(string $cp): static
    {
        $this->cp = $cp;

        return $this;
    }

    public function getVille(): ?string
    {
        return $this->ville;
    }

    public function setVille(string $ville): static
    {
        $this->ville = $ville;

        return $this;
    }

    /**
     * @return Collection<int, Employe>
     */
    public function getEmployes(): Collection
    {
        return $this->employes;
    }

    public function addEmploye(Employe $employe): static
    {
        if (!$this->employes->contains($employe)) {
            $this->employes->add($employe);
            $employe->setEntreprise($this);
        }

        return $this;
    }

    public function removeEmploye(Employe $employe): static
    {
        if ($this->employes->removeElement($employe)) {
            // set the owning side to null (unless already changed)
            if ($employe->getEntreprise() === $this) {
                $employe->setEntreprise(null);
            }
        }

        return $this;
    }
    public function getAdresseComplete(): string
    {
        return $this->adresse . ' ' . $this->cp . ' ' . $this->ville;
    }

    public function __toString(): string
    {
        return $this->raisonSocial ;
    }
}

src/Form/EntrepriseType.php
<?php

namespace App\Form;

use App\Entity\Entreprise;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\DateType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;

class EntrepriseType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('raisonSocial', TextType::class,
            [
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('dateCreation', DateType::class,
            [
                'widget' => 'single_text',
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('adresse', TextType::class,
            [
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('cp', TextType::class, 
            [
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('ville', TextType::class, 
            [
                'attr' => [
                    'class' => 'form-control'
                ]
            ])
            ->add('Valider', SubmitType::class,
            [
                'attr' => [
                    'class' => 'btn btn-success'
                ]
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Entreprise::class,
        ]);
    }
}

src/Controller/EntrepriseController.php
<?php

namespace App\Controller;

use App\Entity\Entreprise;
use App\Form\EntrepriseType;
use App\Repository\EntrepriseRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;

class EntrepriseController extends AbstractController
{
    #[Route('/entreprise', name: 'app_entreprise')]
    public function index(EntrepriseRepository $entrepriseRepository): Response
    {
        //$entreprises = $entrepriseRepository->findAll();
        $entreprises = $entrepriseRepository->findBy([], ["raisonSocial" => "DESC"]);
        return $this->render('entreprise/index.html.twig', [
            'entreprises' => $entreprises
        ]);
    }
    #[Route('/entreprise/new', name: 'new_entreprise')]
    #[Route('/entreprise/{id}/edit', name: 'edit_entreprise')]
    //$entreprise is null, that means if there is no entreprise in parameter 
    //we will create new one
    public function new_edit(Entreprise $entreprise = null, Request $request, EntityManagerInterface $entityManager): Response
    {
        if(!$entreprise){
            //create new entreprise
            $entreprise = new Entreprise();
        }
        
        //create the form
        $form = $this->createForm(EntrepriseType::class, $entreprise);
        
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            // $form->getData() holds the submitted values
            // but, the original `$task` variable has also been updated
            $entreprise = $form->getData();
            // tell Doctrine you want to (eventually) save the Product (no queries yet)
            $entityManager->persist($entreprise);

            // actually executes the queries (i.e. the INSERT query)
            $entityManager->flush();

            // ... perform some action, such as saving the task to the database
            return $this->redirectToRoute('app_entreprise');
        }

        //display the form in the view
        return $this->render('entreprise/new.html.twig', [
            'formAddEntreprise' => $form,
            'edit' => $entreprise->getId()
        ]);
    }


    #[Route('/entreprise/{id}/delete', name: 'delete_entreprise')]
    public function delete(Entreprise $entreprise, EntityManagerInterface $entityManager): Response
    {
        $entityManager->remove($entreprise);
        $entityManager->flush();
        return $this->redirectToRoute('app_entreprise');
    }

    #[Route('/entreprise/{id}', name: 'show_entreprise')]
    public function show(Entreprise $entreprise): Response
    {
        return $this->render('entreprise/show.html.twig', [
            'entreprise' => $entreprise
        ]);
    }
}

templates/entreprise/index.html.twig
    {% extends 'base.html.twig' %}

    {% block title %}Liste des Entreprises{% endblock %}

    {% block body %}
        <h1>Liste des Entreprises</h1>
            <a class="btn btn-success" href ="{{path('new_entreprise')}} ">Ajouter une entreprise</a><br>
            {% for entreprise in entreprises %}
                <a href ="{{path('show_entreprise', {'id': entreprise.id})}} ">{{entreprise}}</a>
                <a class="btn btn-warning" href ="{{path('edit_entreprise', {'id': entreprise.id})}} ">Edit</a>
                <a class="btn btn-danger" href ="{{path('delete_entreprise', {'id': entreprise.id})}} ">Delete</a>
                <br>
            {% endfor %}
    {% endblock %}

templates/entreprise/new.html.twig
    {% extends 'base.html.twig' %}

    {% block title %}Liste des Entreprises{% endblock %}

    {% block body %}

        {% if edit %}
            <h1>editer une entreprise</h1>
        {% else %}
            <h1>Ajouter une entreprise</h1>
        {% endif %}
        {# {{ form(formAddEntreprise) }} #}
        {{ form_start(formAddEntreprise) }}
            {{ form_row(formAddEntreprise.raisonSocial) }}
            {{ form_row(formAddEntreprise.dateCreation) }}
            <div class="row">
                <div class="col-sm">
                    {{ form_row(formAddEntreprise.adresse) }}
                </div>
                <div class="col-sm">
                    {{ form_row(formAddEntreprise.cp) }}
                </div>
                <div class="col-sm">
                    {{ form_row(formAddEntreprise.ville) }}
                </div>
            </div>
        {{ form_end(formAddEntreprise) }}

    {% endblock %}

templates/entreprise/show.html.twig
    {% extends 'base.html.twig' %}

    {% block title %}Liste des Entreprises{% endblock %}

    {% block body %}
        <h1>Détails d'une Entreprise</h1>
        <h2>{{ entreprise }}</h2>
        <p>
            L'adresse : {{ entreprise.adresseComplete }} <br>
            Date de Creation : {{ entreprise.dateCreation | date("d.m.Y") }} <br>
        </p>

        <h3>Liste des Salariés</h3>
        {% if entreprise.employes | length > 0 %}
            <table class="table table-striped">
                <thead>
                    <tr>
                        <th>Employe</th>
                    </tr>
                </thead>
                <tbody>
                    {% for employe in entreprise.employes %}
                        <tr><td><a href="{{ path('show_employe', {'id':employe.id}) }}"> {{ employe }}</a></td></tr>
                    {% endfor %}
                </tbody>
        {% else %}
            <p>Aucun salarié dans cette entreprise</p>
         {% endif %}   
    {% endblock %}